#include "positivegrid/exchange_server.h"

#include <chrono>
#include <string>
#include <thread>


int main()
{
    xs::ExchangeServer server("greeting", {}, {}, 0, nullptr);
    server.onCmd(
        "GetMessage",
        [&server](const std::string&, const std::string&) {
            const auto name = server.runCmd("GetName", "");
            server.postEvent("NotifyGetMessage", "");
            return "Hello, " + name + "!";
        }
    );
 
    using namespace std::chrono_literals; 
    for (;;) {
        std::this_thread::sleep_for(1s);
    }
}
