#ifndef XS_TEST_SERVER_H_INCLUDED
#define XS_TEST_SERVER_H_INCLUDED

#include <boost/optional.hpp>
#include <nlohmann/json.hpp>

#include <string>


namespace xs { namespace test
{
    class Service final
    {
    public:
        Service() = delete;
        Service(const Service&) = delete;
        Service(Service&&) noexcept = default;
        ~Service() noexcept = default;

        Service& operator=(const Service&) = delete;
        Service& operator=(Service&&) = delete;

        explicit Service(const nlohmann::json& object);
        static bool verify(const nlohmann::json& object) noexcept;

        bool isCommand() const noexcept;
        bool isEvent() const noexcept;

    private:
        Service(std::string name, nlohmann::json response) noexcept;
        Service(std::string name) noexcept;

    public:
        std::string name_;
        boost::optional<nlohmann::json> request_;
        boost::optional<nlohmann::json> response_;
    };
} }

#endif
